import Action from 'commons/redux/Action';

import Member from 'member/api/model/Member';

import actionTypes from './type';
import SignupPayload from '../payload/SignupPayload';

export interface Actions {
  request: (signupPayload: SignupPayload) => Action<SignupPayload>;
  requestSuccess: (member: Member) => Action<Member>;
  requestFailure: (error: Error) => Action;
}

export const actions: Actions = {
    request(signupPayload: SignupPayload): Action<SignupPayload> {
      return {
          type: actionTypes.REQUEST,
          payload: signupPayload,
        };
    },

    requestSuccess(member: Member): Action<Member> {
      return {
          type: actionTypes.REQUEST,
          payload: member,
        };
    },

    requestFailure(error: Error): Action {
      return {
          type: actionTypes.REQUEST,
          error: error,
        };
    },
};

export default actions;
